#include <iostream>
#include <fstream>
#include <cstdlib> // exit()
#include <vector>
#include <string.h>
#include <sstream>
#include <windows.h>

#define up = "up"
#define upnD = "up and down"
#define down = "down"
#define right_ = "right"
#define left_ = "left"
#define straight = "straight"
#define around = "around"
#define add = "+"
#define subtract = "-"
#define addSubtract = "+-"

const std::string gF[] = {"A_gFlat_part_1_AND_green:", // right
                          "A_gFlat_part_1_AND_red:",   // up
                          "A_gFlat_part_1_AND_cyan:",  // left
                          "A_gFlat_part_1_AND_red:",   // up
                          "A_gFlat_part_2_AND_green:", // right
                          "A_gFlat_part_2_AND_red:",   // up
                          "A_gFlat_part_3_XOR_red:",   // up
                          "A_gFlat_part_4_OR_cyan:",   // left
                          "A_gFlat_part_4_OR_red:"};   // up

const std::string dF[] = {"B_dFlat_part_1_AND_red:", // up
                          "B_dFlat_part_1_AND_blue:",   // straight
                          "B_dFlat_part_1_AND_red:",  // up
                          "B_dFlat_part_1_AND_cyan:",   // left
                          "B_dFlat_part_2_AND_red:", // up
                          "B_dFlat_part_2_AND_cyan:",   // left
                          "B_dFlat_part_3_XOR_blue:",   // straight
                          "B_dFlat_part_4_OR_red:",   // up
                          "B_dFlat_part_4_OR_cyan:"};   // left

const std::string aF[] = {"C_aFlat_part_1_AND_cyan:", // left
                          "C_aFlat_part_1_AND_yellow:",   // down
                          "C_aFlat_part_1_AND_blue:",  // straight
                          "C_aFlat_part_1_AND_red:",   // up
                          "C_aFlat_part_2_AND_cyan:", // left
                          "C_aFlat_part_2_AND_red:",   // up
                          "C_aFlat_part_3_XOR_yellow:",   // down
                          "C_aFlat_part_4_OR_blue:",   // straight
                          "C_aFlat_part_4_OR_red:"};   // up

const std::string eF[] = {"D_eFlat_part_1_AND_red:", // up
                          "D_eFlat_part_1_AND_red:",   // up
                          "D_eFlat_part_1_AND_yellow:",  // down
                          "D_eFlat_part_1_AND_blue:",   // straight
                          "D_eFlat_part_2_AND_red:", // up
                          "D_eFlat_part_2_AND_blue:",   // straight
                          "D_eFlat_part_3_XOR_red:",   // up
                          "D_eFlat_part_4_OR_yellow:",   // down
                          "D_eFlat_part_4_OR_blue:"};   // straight


const std::string bF[] = {"E_bFlat_part_1_AND_blue:", // straight
                          "E_bFlat_part_1_AND_green:",   // right
                          "E_bFlat_part_1_AND_red:",  // up
                          "E_bFlat_part_1_AND_yellow:",   // down
                          "E_bFlat_part_2_AND_blue:", // straight
                          "E_bFlat_part_2_AND_yellow:",   // down
                          "E_bFlat_part_3_XOR_green:",   // right
                          "E_bFlat_part_4_OR_red:",   // up
                          "E_bFlat_part_4_OR_yellow:"};   // down

const std::string F[] = {"F_part_1_AND_yellow:", // down
                          "F_part_1_AND_red:",   // up
                          "F_part_1_AND_green:",  // right
                          "F_part_1_AND_red:",   // up
                          "F_part_2_AND_yellow:", // down
                          "F_part_2_AND_red:",   // up
                          "F_part_3_XOR_red:",   // up
                          "F_part_4_OR_green:",   // right
                          "F_part_4_OR_red:"};   // up

const std::string C[] = {"G_C_part_1_AND_red:", // up
                          "G_C_part_1_AND_blue:",   // straight
                          "G_C_part_1_AND_red:",  // up
                          "G_C_part_1_AND_green:",   // right
                          "G_C_part_2_AND_red:", // up
                          "G_C_part_2_AND_green:",   // right
                          "G_C_part_3_XOR_blue:",   // straight
                          "G_C_part_4_OR_red:",   // up
                          "G_C_part_4_OR_green:"};   // right

const std::string G[] = {"H_G_part_1_AND_green:", // right
                          "H_G_part_1_AND_orange:",   // up and down
                          "H_G_part_1_AND_blue:",  // straight
                          "H_G_part_1_AND_red:",   // up
                          "H_G_part_2_AND_green:", // right
                          "H_G_part_2_AND_red:",   // up
                          "H_G_part_3_XOR_orange:",   // up and down
                          "H_G_part_4_OR_blue:",   // straight
                          "H_G_part_4_OR_red:"};   // up

const std::string D[] = {"I_part_1_AND_red:", // up
                          "I_part_1_AND_violet:",   // around
                          "I_part_1_AND_orange:",  // up and down
                          "I_part_1_AND_blue:",   // straight
                          "I_part_2_AND_red:", // up
                          "I_part_2_AND_blue:",   // straight
                          "I_part_3_XOR_violet:",   // around
                          "I_part_4_OR_orange:",   // up and down
                          "I_part_4_OR_blue:"};   // straight

const std::string A[] = {"J_A_part_1_AND_blue:", // straight
                          "J_A_part_1_AND_green:",   // right
                          "J_A_part_1_AND_violet:",  // around
                          "J_A_part_1_AND_orange:",   // up and down
                          "J_A_part_2_AND_blue:", // straight
                          "J_A_part_2_AND_orange:",   // up and down
                          "J_A_part_3_XOR_green:",   // right
                          "J_A_part_4_OR_violet:",   // around
                          "J_A_part_4_OR_orange:"};   // up and down

const std::string E[] = {"K_E_part_1_AND_orange:", // up and down
                          "K_E_part_1_AND_red:",   // up
                          "K_E_part_1_AND_green:",  // right
                          "K_E_part_1_AND_violet:",   // around
                          "K_E_part_2_AND_orange:", // up and down
                          "K_E_part_2_AND_violet:",   // around
                          "K_E_part_3_XOR_red:",   // up
                          "K_E_part_4_OR_green:",   // right
                          "K_E_part_4_OR_violet:"};   // around

const std::string B[] = {"L_B_part_1_AND_violet:", // around
                          "L_B_part_1_AND_cyan:",   // left
                          "L_B_part_1_AND_red:",  // up
                          "L_B_part_1_AND_green:",   // right
                          "L_B_part_2_AND_violet:", // around
                          "L_B_part_2_AND_green:",   // right
                          "L_B_part_3_XOR_cyan:",   // left
                          "L_B_part_4_OR_red:",   // up
                          "L_B_part_4_OR_green:"};   // right

// I use this in the 12 pattern finding functions, to compare stings.
const std::string frequencies[] = {"466.16", // blue, keAS
                                   "415.3",  // cyan, keGS
                                   "415.3",  // cyan, keGS
                                   "415.3",  // cyan, keGS
                                   "415.3",  // cyan, keGS
                                   "415.3",  // cyan, keGS
                                   "349.23", // yellow, keF
                                   "277.18", // red, keCS
                                   "349.23", // yellow, keF
                                   "440",    // blue, keA
                                   "392",    // green, keG
                                   "261.63", // red, keC
                                   "261.63", // red, keC
                                   "349.23", // yellow, keF
                                   "493.88", // violet, keB
                                   "261.63", // red, keC
                                   "261.63", // red, keC
                                   "329.63", // orange, keE
                                   "311.13", // red, keDS
                                   "415.3",  // cyan, keGS
                                   "293.66", // red, keD
                                   "415.3",  // cyan, keGS
                                   "311.13", // red, keDS
                                   "369.99", // green, keFS
                                   "392",    // green, keG
                                   "392"};   // green, keG

using namespace std;

int count_up = 0;
int count_upnD = 0;
int count_down = 0;
int count_right_ = 0;
int count_left_ = 0;
int count_straight = 0;
int count_around = 0;

// This is used for playing sound
enum EFrequency {
	keRest = 0,
	keC = 262, keCS = 277, keD = 294, keDS = 311, keE = 330, keF = 349,
	keFS = 370, keG = 392, keGS = 415, keA = 440, keAS = 466, keB = 494,
};
enum EDuration {
	ke16th = 200, ke8th = (ke16th << 1), keQuart = (ke8th << 1),
	keHalf = (keQuart << 1), keWhole = (keQuart << 1)
};

class CNote {
public:
	CNote(unsigned int uiFrequency, unsigned int uiDuration)
		: muiFrequency(uiFrequency), muiDuration(uiDuration) {}
	void Play () {
		if (muiFrequency > 0) {
			Beep(muiFrequency, muiDuration);
		} else {
			Sleep(muiDuration);
		}
	}
	unsigned int muiFrequency;
	unsigned int muiDuration;
};

class CMelody {
public:
	void AddNote(unsigned int uiFrequency, unsigned int uiDuration) {
		mqNotes.push_back(CNote(uiFrequency, uiDuration));
	}
	void Play () {
		std::vector<CNote>::iterator qIter;
		for (qIter = mqNotes.begin(); qIter != mqNotes.end(); ++qIter) {
			qIter->Play();
		}
	}
	std::vector<CNote> mqNotes;
};

EFrequency gF_EF [] = {keFS, keDS, keGS, keCS, keFS, keCS, keDS, keGS, keCS};
EFrequency dF_EF [] = {keCS, keAS, keDS, keGS, keCS, keGS, keAS, keDS, keGS};
EFrequency aF_EF [] = {keGS, keF, keAS, keDS, keGS, keDS, keF, keAS, keDS};
EFrequency eF_EF [] = {keDS, keC, keF, keAS, keDS, keAS, keC, keF, keAS};
EFrequency bF_EF [] = {keAS, keG, keC, keF, keAS, keF, keG, keC, keF};
EFrequency F_EF [] = {keF, keD, keG, keC, keF, keC, keD, keG, keC};
EFrequency C_EF [] = {keC, keA, keD, keG, keC, keG, keA, keD, keG};
EFrequency G_EF [] = {keG, keE, keA, keD, keG, keD, keE, keA, keD};
EFrequency D_EF [] = {keD, keRest, keE, keA, keD, keA, keRest, keE, keA};
EFrequency A_EF [] = {keA, keFS, keRest, keE, keA, keE, keFS, keRest, keE};
EFrequency E_EF [] = {keE, keCS, keFS, keRest, keE, keRest, keCS, keFS, keRest};
EFrequency B_EF [] = {keRest, keGS, keCS, keFS, keRest, keFS, keGS, keCS, keFS};

int gF_C [] = {ke8th, ke8th + ke16th, ke16th, ke8th + ke16th, ke8th, ke8th + ke16th, ke8th + ke16th, ke16th, ke8th + ke16th};
int dF_C [] = {ke8th + ke16th, ke16th, ke8th + ke16th, ke16th, ke8th + ke16th, ke16th, ke16th, ke8th + ke16th, ke16th};
int aF_C [] = {ke16th, ke8th, ke16th, ke8th + ke16th, ke16th, ke8th + ke16th, ke8th, ke16th, ke8th + ke16th};
int eF_C [] = {ke8th + ke16th, ke8th + ke16th, ke8th, ke16th, ke8th + ke16th, ke16th, ke8th + ke16th, ke8th, ke16th};
int bF_C [] = {ke16th, ke8th, ke8th + ke16th, ke8th, ke16th, ke8th, ke8th, ke8th + ke16th, ke8th};
int F_C [] = {ke8th, ke8th + ke16th, ke8th, ke8th + ke16th, ke8th, ke8th + ke16th, ke8th + ke16th, ke8th, ke8th + ke16th};
int C_C [] = {ke8th + ke16th, ke16th, ke8th + ke16th, ke8th, ke8th + ke16th, ke8th, ke16th, ke8th + ke16th, ke8th};
int G_C [] = {ke8th, ke8th + ke16th, ke16th, ke8th + ke16th, ke8th, ke8th + ke16th, ke8th + ke16th, ke16th, ke8th + ke16th};
int D_C [] = {ke8th + ke16th, ke16th, ke8th + ke16th, ke16th, ke8th + ke16th, ke16th, ke16th, ke8th + ke16th, ke16th};
int A_C [] = {ke16th, ke8th, ke16th, ke8th + ke16th, ke16th, ke8th + ke16th, ke8th, ke16th, ke8th + ke16th};
int E_C [] = {ke8th + ke16th, ke8th + ke16th, ke8th, ke16th, ke8th + ke16th, ke16th, ke8th + ke16th, ke8th, ke16th};
int B_C [] = {ke16th, ke16th, ke8th + ke16th, ke8th, ke16th, ke8th, ke16th, ke8th + ke16th, ke8th};

int gF_D [] = {count_right_++, count_up++, count_left_++, count_up++, count_right_++, count_up++, count_up++, count_left_++, count_up++};
int dF_D [] = {count_up++, count_straight++, count_up++, count_left_++, count_up++, count_left_++, count_straight++, count_up++, count_left_++};
int aF_D [] = {count_left_++, count_down++, count_straight++, count_up++, count_left_++, count_up++, count_down++, count_straight++, count_up++};
int eF_D [] = {count_up++, count_up++, count_down++, count_straight++, count_up++, count_straight++, count_up++, count_down++, count_straight++};
int bF_D [] = {count_straight++, count_right_++, count_up++, count_down++, count_straight++, count_down++, count_right_++, count_up++, count_down++};
int F_D [] = {count_down++, count_up++, count_right_++, count_up++, count_down++, count_up++, count_up++, count_right_++, count_up++};
int C_D [] = {count_up++, count_straight++, count_up++, count_right_++, count_up++, count_right_++, count_straight++, count_up++, count_right_++};
int G_D [] = {count_right_++, count_upnD++, count_straight++, count_up++, count_right_++, count_up++, count_upnD++, count_straight++, count_up++};
int D_D [] = {count_up++, count_around++, count_upnD++, count_straight++, count_up++, count_straight++, count_around++, count_upnD++, count_straight++};
int A_D [] = {count_straight++, count_right_++, count_around++, count_upnD++, count_straight++, count_upnD++, count_right_++, count_around++, count_upnD++};
int E_D [] = {count_upnD++, count_up++, count_right_++, count_around++, count_upnD++, count_around++, count_up++, count_right_++, count_around++};
int B_D [] = {count_around++, count_left_++, count_up++, count_right_++, count_around++, count_right_++, count_left_++, count_up++, count_right_++};

void findMatch(){
    std::ifstream fin1("holdSentence.txt", fstream::app), fin2("holdDatabase.txt", fstream::app);
    if (!fin1 || !fin2) { std::cerr<<"file error\n"; std::exit(1); }
    int count = 0;
    int countOne = 0;
    string holdD;
    string holdS;
    getline( fin1, holdS );

    while( getline( fin2, holdD ) ){
        std::ofstream fout("tempData.txt");
        if (!fout) { std::cerr<<"file error\n"; std::exit(1); }
        fout << holdD;
        fout.close();

        std::ifstream fin3("tempData.txt", fstream::app);
        if (!fin3) { std::cerr<<"file error\n"; std::exit(1); }
        string tempD;
        getline(fin3, tempD);

        for (string::size_type a = 0; a < holdS.length(); ++a) {
            for (string::size_type b = 0; b < tempD.length(); ++b) {
                if ((holdS[a] == tempD[b]) && (holdS[a] != ' ')) {
                    count++;
                    if (tempD[b] == '1') {
                        countOne++;
                    }
                }
            }
        }
        if(count > 2 && countOne > 0){
            cout << endl << tempD << endl;
            break;
        }
        fin3.close();
        count = 0;
        countOne = 0;
    }
    fin1.close();
    fin2.close();
}

void readSentence(std:: string direction, int amount){
    std::ofstream newLine("holdSentence.txt", fstream::app);
    if (!newLine) { std::cerr<<"file error\n"; std::exit(1); }
    newLine << " " << direction << endl;
    newLine.close();
    std::ifstream fin1("holdSentence.txt", fstream::app), fin2("holdDatabase.txt", fstream::app);
    if (!fin1 || !fin2) { std::cerr<<"file error\n"; std::exit(1); }

    string temp1;
    string temp2;
    string temp3;
    int count = 0;

    getline(fin1, temp1);

    while( getline( fin2, temp2 ) ){
        if(temp1 == temp2 && count == 0){
            count++;
        }
        else if(temp1 == temp2 && count > 0){
            count++;
        }
    }
    fin1.close();
    fin2.close();

    std::ofstream fout("holdDatabase.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    if(count == 0){
        fout << temp1 << endl;
    }
    fout.close();
}

void writeSentence(std::string str){

    std::ofstream fout("holdSentence.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    char * writable = new char[str.size() + 1];
    std::copy(str.begin(), str.end(), writable);
    writable[str.size()] = '\0'; // don't forget the terminating 0

    if (strncmp(writable, " ", 1) == 0) {
        cout << writable[1];
        fout << writable[1];
    }
    else if (strncmp(writable, " ", 1) != 0 ) {
        cout << " " << writable;
        fout << " " << writable;
    }
    fout.close();
    delete[] writable;
}

// This plays the sound


void playSound(std::string note, std::string note2){
    CMelody songSound;

    for (int i = 0; i < 9; ++i) {
        if(note == gF[i]){
            songSound.AddNote(gF_EF[i], gF_C[i]); // compare chord x
            writeSentence(note2);
            gF_D[i];
        }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == dF[i]){
        songSound.AddNote(dF_EF[i], dF_C[i]); // compare chord h
        writeSentence(note2);
        dF_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == aF[i]){
        songSound.AddNote(aF_EF[i], aF_C[i]); // compare chord b
        writeSentence(note2);
        aF_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == eF[i]){
        songSound.AddNote(eF_EF[i], eF_C[i]); // compare chord s
        writeSentence(note2);
        eF_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == bF[i]){
        songSound.AddNote(bF_EF[i], bF_C[i]); // compare chord a
        writeSentence(note2);
        bF_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == F[i]){
        songSound.AddNote(F_EF[i], F_C[i]); // compare chord g
        writeSentence(note2);
        F_D[i];
    }

}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == C[i]){
        songSound.AddNote(C_EF[i], C_C[i]); // compare chord l
        writeSentence(note2);
        C_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == G[i]){
        songSound.AddNote(G_EF[i], G_C[i]); // compare chord k
        writeSentence(note2);
        G_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == D[i]){
        songSound.AddNote(D_EF[i], D_C[i]); // compare chord u
        writeSentence(note2);
        D_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == A[i]){
        songSound.AddNote(A_EF[i], A_C[i]); // compare chord j
        writeSentence(note2);
        A_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == E[i]){
        songSound.AddNote(E_EF[i], E_C[i]); // compare chord r
        writeSentence(note2);
        E_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////
for (int i = 0; i < 9; ++i) {
    if(note == B[i]){
        songSound.AddNote(B_EF[i], B_C[i]); // compare chord o
        writeSentence(note2);
        B_D[i];
    }
}
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    songSound.Play();
}


// These next twelve functions are used to find the pattern in the csv file.

void gFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {23, 18, 1, 7, 23, 7, 18, 1, 7};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << gF[i] << endl;
        }
    }

    fout.close();
}

void dFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {7, 0, 18, 1, 7, 1, 0, 18, 1};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << dF[i] << endl;
        }
    }

    fout.close();
}

void aFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {1, 6, 0, 18, 1, 18, 6, 0, 18};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << aF[i] << endl;
        }
    }

    fout.close();
}

void eFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {18, 11, 6, 0, 18, 0, 11, 6, 0};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << eF[i] << endl;
        }
    }

    fout.close();
}

void bFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {0, 10, 11, 6, 0, 6, 10, 11, 6};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << bF[i] << endl;
        }
    }

    fout.close();
}

void F_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {6, 20, 10, 11, 6, 11, 20, 10, 11};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << F[i] << endl;
        }
    }

    fout.close();
}

void C_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {11, 9, 20, 10, 11, 10, 9, 20, 10};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << C[i] << endl;
        }
    }

    fout.close();
}

void G_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {10, 17, 9, 20, 10, 20, 17, 9, 20};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << G[i] << endl;
        }
    }

    fout.close();
}

void D_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {20, 14, 17, 9, 20, 9, 14, 17, 9};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << D[i] << endl;
        }
    }

    fout.close();
}

void A_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {9, 23, 14, 17, 9, 17, 23, 14, 17};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << A[i] << endl;
        }
    }

    fout.close();
}

void E_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {17, 7, 23, 14, 17, 14, 7, 23, 14};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << E[i] << endl;
        }
    }

    fout.close();
}

void B_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {14, 1, 7, 23, 14, 23, 1, 7, 23};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << B[i] << endl;
        }
    }

    fout.close();
}

// This allows me to read the csv file a line at a time, I got it from the internet
void readCSV(std::istream &input, std::vector< std::vector<std::string> > &output){
	std::string csvLine;
	// read every line from the stream
	while( std::getline(input, csvLine) ){
		std::istringstream csvStream(csvLine);
		std::vector<std::string> csvColumn;
		std::string csvElement;
		// read every element from the line that is seperated by commas
		// and put it into the vector or strings
		while( std::getline(csvStream, csvElement, ',') ){
			csvColumn.push_back(csvElement);
		}
		output.push_back(csvColumn);
	}
}

void openCsv(){

    int itemnum = 0;
    // I read the csv file and find the patterns then write the results to the pattern text file
                std::fstream file("file_out.csv", ios::in);
                if (!file) { std::cerr<<"file error\n"; std::exit(1); }

                // typedef to save typing for the following object
                typedef std::vector< std::vector<std::string> > csvVector;
                csvVector csvData;

                readCSV(file, csvData);
                // print out read data to prove reading worked
                for(csvVector::iterator I = csvData.begin(); I != csvData.end(); ++I){
                    for(std::vector<std::string>::iterator J = I->begin(); J != I->end(); ++J){
                        itemnum++;
                        string T = *J;

                        gFlat(itemnum, T);
                        dFlat(itemnum, T);
                        aFlat(itemnum, T);
                        eFlat(itemnum, T);
                        bFlat(itemnum, T);
                        F_(itemnum, T);
                        C_(itemnum, T);
                        G_(itemnum, T);
                        D_(itemnum, T);
                        A_(itemnum, T);
                        E_(itemnum, T);
                        B_(itemnum, T);
                    }

                itemnum = 0;

                }
                // I close the csv file
                file.close();
}

int main()
{
    std::ofstream aSentence("file_out.txt");
    if (!aSentence) { std::cerr<<"file error\n"; std::exit(1); }
    char theSentence[4096];
    cout << "Enter your sentence, end it with a period: ";
    cin.getline (theSentence,4096);
    aSentence << theSentence;
    aSentence.close();

    std::ifstream in("file_out.txt");
    std::ofstream fin3("holdSentence.txt");
    if (!in || !fin3) { std::cerr<<"file error\n"; std::exit(1); }
    fin3.close();

    string temp;
    float c_;
    int itemnum = 0;
    bool word = false;
    char letters[] = "abcdefghijklmnopqrstuvwxyz";
    float freqs[] = {466.16, 415.30, 415.30, 415.30, 415.30, 415.30, 349.23, 277.18,
    349.23, 440, 392, 261.63, 261.63, 349.23, 493.88, 261.63, 261.63, 329.63, 311.13,
    415.30, 293.66, 415.30, 311.13, 369.99, 392, 392};
    char *this_letter;
    int letter_index;

    // I convert the input to musical frequency values
    getline( in, temp );

    for (unsigned int a=0;a < temp.length();a++){
        if ( temp[a] == '.' || temp[a] == '?' || temp[a] == '!'){

            temp[a] = '\n';
            // I open then close the file to erase the previous text
            std::ofstream pattern("pattern_file_out.txt");
            pattern.close();

            std::ifstream fin("file_out.txt");
            std::ofstream fout2("file_out.csv");
            std::ofstream fout_3("file_out_2.txt");
            if (!fin || !fout2 || !fout_3) { std::cerr<<"file error\n"; std::exit(1); }

            while ((c_ = fin.get()) != EOF) {
                if (c_ == '\'') continue; // skip apostrophe
                if (std::isalpha(c_)) {
                    if (word) fout_3<<" ";
                    if (word) fout2<<',';

                    if ((this_letter = strchr(letters, tolower(c_))) != NULL){
                        fout_3 << this_letter[0] << endl;
                        letter_index = this_letter - letters;
                        c_ = freqs[letter_index];
                    }

                    fout2 << c_;
                    word = true;
                }

                else if (word) {
                    fout2<<'\n';
                    word = false;
                }
            }

            fin.close();
            fout2.close();
            fout_3.close();

        }
    }

    in.close();

    openCsv();

    cout << endl << "Input sentence to program, from input.txt;" << endl;
    // Now I take the text and make it into a sound

    std::ifstream inputDesign("pattern_file_out.txt");
    std::ifstream inputChar("file_out_2.txt");
    if (!inputDesign || !inputChar) { std::cerr<<"file error\n"; std::exit(1); }

    vector<string> text_file1;
    string temp1;
    string temp2;
    while( getline( inputDesign, temp1), getline( inputChar, temp2) ){
        string note;
        string note2;
        note = temp1;
        note2 = temp2;

        playSound(note, note2);

        text_file1.push_back( temp1 );
    }

    inputDesign.close();
    inputChar.close();

    if(count_up > count_upnD && (count_up > count_down) && (count_up > count_right_) && (count_up > count_left_) && (count_up > count_straight) && (count_up > count_around))
        readSentence("1", count_up);
    else if(count_upnD > count_up && (count_upnD > count_down) && (count_upnD > count_right_) && (count_upnD > count_left_) && (count_upnD > count_straight) && (count_upnD > count_around))
        readSentence("2", count_upnD);
    else if(count_down > count_upnD && (count_down > count_up) && (count_down > count_right_) && (count_down > count_left_) && (count_down > count_straight) && (count_down > count_around))
        readSentence("3", count_down);
    else if(count_right_ > count_upnD && (count_right_ > count_down) && (count_right_ > count_up) && (count_right_ > count_left_) && (count_right_ > count_straight) && (count_right_ > count_around))
        readSentence("4", count_right_);
    else if(count_left_ > count_upnD && (count_left_ > count_down) && (count_left_ > count_right_) && (count_left_ > count_up) && (count_left_ > count_straight) && (count_left_ > count_around))
        readSentence("5", count_left_);
    else if(count_straight > count_upnD && (count_straight > count_down) && (count_straight > count_right_) && (count_straight > count_left_) && (count_straight > count_up) && (count_straight > count_around))
        readSentence("6", count_straight);
    else if(count_around > count_upnD && (count_around > count_down) && (count_around > count_right_) && (count_around > count_left_) && (count_around > count_straight) && (count_around > count_up))
        readSentence("7", count_around);

    findMatch();
    cout << endl << endl;

    // I pause the console window so you can read the screen results
    system ("pause");
}
